unit FolderDialog;

interface

uses
  Windows, SysUtils, Classes, Forms, Dialogs, ShellApi, ShlObj, ActiveX;

type
  TFolderDialog = class(TCommonDialog)
  private
    FTitle: string;
    FFolderPath: TFileName;
  protected
    { Protected 錾 }
  public
    constructor Create(AOwner: TComponent); override;
    function Execute: Boolean; override;
  published
    property FolderPath: TFileName read FFolderPath write FFolderPath;
    property Title: string read FTitle write FTitle;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('External', [TFolderDialog]);
end;

{ TFolderDialog }

constructor TFolderDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FTitle := '';
  FFolderPath := '';
end;

function TFolderDialog.Execute: Boolean;
var
  BrowseInfo: TBrowseInfo;
  FolderName, Path: array[0..MAX_PATH] of Char;
  ItemIDList: PItemIDList;
  Allocator: IMalloc;
begin
  Result := False;

  if SHGetMalloc(Allocator) = E_FAIL then Exit;

  with BrowseInfo do
  begin
    hwndOwner := Application.Handle;
    pidlRoot := nil;
    pszDisplayName := FolderName;
    lpszTitle := PChar(FTitle);
    ulFlags := BIF_RETURNONLYFSDIRS;
    lpfn := nil;
  end;

  ItemIDList := SHBrowseForFolder(BrowseInfo);
  if ItemIDList = nil then Exit;

  SHGetPathFromIDList(ItemIDList, Path);
  FFolderPath := StrPas(Path);

  Allocator.Free(ItemIDList);

  Result := True;
end;

end.
